%{
/* Scanner for Calculator */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "scan.h"
%}

                /* Macro defining the exponent in double const */
EXP     ((E|e)("+"|"-")?[0-9]+)

%%
[0-9]+          {
                    yylval.int_value = atoi(yytext);
                    return INT_CONST;
                }
([0-9]*"."[0-9]+{EXP}?)|([0-9]+"."[0-9]+{EXP}?)|([0-9]+{EXP}) {
                    /* Double constant */
                    yylval.double_value = atof(yytext);
                    return DOUBLE_CONST;
                }
"+"             { return PLUS; }
"-"             { return MINUS; }
"*"             { return MULT; }
"/"             { return DIV; }
"("             { return LPAR; }
")"             { return RPAR; }
(" "|\t)*       {}                  /* Skip space */
.               { return ILLEGAL; } /* Other character */
\n              { return ENDL; }

%%

int yywrap() { return 1; }
